@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package snovis with version v1r1.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\build_prog_snovis
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_snovis_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_snovis_path=%obuild_snovis_path:~0,-12%

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

SET obuild_verbose=no
SET obuild_debug=no
SET obuild_optimize=yes
SET obuild_set_x=no

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug=yes
  SHIFT
  GOTO next_arg
:end_if_g

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF %obuild_debug% == yes SET obuild_optimize=no

IF "%OBUILD_PLATFORM%" == "" (
  IF "%OS%" == "" ECHO Environment variable OS not found. & GOTO obuild_return
  SET obuild_platform=%OS%
) ELSE (
  SET obuild_platform=%OBUILD_PLATFORM%
)

IF "%obuild_platform%" == "" (
  ECHO obuild_platform variable not defined.
  GOTO obuild_return
)

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF NOT EXIST "%obuild_snovis_path%\%obuild_dir_bin%" MKDIR "%obuild_snovis_path%\%obuild_dir_bin%"

IF NOT EXIST "%obuild_snovis_path%\%obuild_dir_bin%" MKDIR "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_snovis_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_snovis_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_snovis_path%\obuild\cpp\obuild_platform.cpp" 1> NUL
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  %obuild_platform% Windows_NT`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_0
SET obuild_cxx_command=cl.exe
:end_if_platform_0
SET obuild_platform_result=
IF "%obuild_cxx_command%" == ""  ECHO Variable obuild_cxx_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  %obuild_platform% Windows_NT`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_1
SET obuild_cxx_optimize=/O2
:end_if_platform_1
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  %obuild_platform% Windows_NT`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_2
SET obuild_cxx_debug=/ZI /Od
:end_if_platform_2
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  %obuild_platform% Windows_NT`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_3
SET obuild_cxx_options=/nologo /DWIN32 /MD /GX /GR /W3
:end_if_platform_3
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_app_prog_snovis_sh_4
  SET obuild_cxx_debug_local=%obuild_cxx_debug%
  GOTO end_if_db_build_app_prog_snovis_sh_4
:else_if_db_build_app_prog_snovis_sh_4
  SET obuild_cxx_debug_local=
:end_if_db_build_app_prog_snovis_sh_4

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_app_prog_snovis_sh_5
  SET obuild_cxx_optimize_local=%obuild_cxx_optimize%
  GOTO end_if_opt_build_app_prog_snovis_sh_5
:else_if_opt_build_app_prog_snovis_sh_5
  SET obuild_cxx_optimize_local=
:end_if_opt_build_app_prog_snovis_sh_5


IF NOT EXIST "%obuild_snovis_path%\%obuild_dir_bin%" MKDIR "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_snovis_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_snovis_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_snovis_path%\obuild\cpp\obuild_find.cpp" 1> NUL
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  snova v2r0p0`) DO SET obuild_snova_path=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT DEFINED obuild_snova_path  ECHO Can't find snova package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  snova v2r0p0`) DO SET obuild_snova_path=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT DEFINED obuild_snova_path  ECHO Can't find snova package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  snova v2r0p0`) DO SET obuild_snova_path=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT DEFINED obuild_snova_path  ECHO Can't find snova package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  snova v2r0p0`) DO SET obuild_snova_path=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT DEFINED obuild_snova_path  ECHO Can't find snova package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  bhep v1r4p2`) DO SET obuild_bhep_path=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT DEFINED obuild_bhep_path  ECHO Can't find bhep package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  snova v2r0p0`) DO SET obuild_snova_path=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT DEFINED obuild_snova_path  ECHO Can't find snova package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  snova v2r0p0`) DO SET obuild_snova_path=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT DEFINED obuild_snova_path  ECHO Can't find snova package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  snova v2r0p0`) DO SET obuild_snova_path=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT DEFINED obuild_snova_path  ECHO Can't find snova package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  snova v2r0p0`) DO SET obuild_snova_path=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT DEFINED obuild_snova_path  ECHO Can't find snova package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  bhep v1r4p2`) DO SET obuild_bhep_path=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT DEFINED obuild_bhep_path  ECHO Can't find bhep package.  && GOTO obuild_return

SET obuild_cxx_includes=/I"%obuild_snovis_path%\source"
SET obuild_cxx_includes=%obuild_cxx_includes% /I"%obuild_snova_path%"
SET obuild_cxx_includes=%obuild_cxx_includes% /I"%obuild_snova_path%\source\GeomUtils\include"
SET obuild_cxx_includes=%obuild_cxx_includes% /I"%obuild_snova_path%\source\SNvertex\include"
SET obuild_cxx_includes=%obuild_cxx_includes% /I"%obuild_snova_path%\source\SNgeom2\include"
SET obuild_cxx_includes=%obuild_cxx_includes% /I"%obuild_bhep_path%"

IF EXIST "%obuild_snovis_path%\%obuild_dir_bin%\app_prog_snovis" RMDIR /S /Q "%obuild_snovis_path%\%obuild_dir_bin%\app_prog_snovis"
IF NOT EXIST "%obuild_snovis_path%\%obuild_dir_bin%\app_prog_snovis" MKDIR "%obuild_snovis_path%\%obuild_dir_bin%\app_prog_snovis"

@IF %obuild_verbose% == yes @ECHO ON 
cd "%obuild_snovis_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\app_prog_snovis\snovis_session.obj  /Tp"..\applications\snovis_session.cc" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_snovis_path%\obuild"

@IF %obuild_verbose% == yes @ECHO OFF 

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  %obuild_platform% Windows_NT`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_13
SET obuild_cxx_linker_command=link.exe
:end_if_platform_13
SET obuild_platform_result=
IF "%obuild_cxx_linker_command%" == ""  ECHO Variable obuild_cxx_linker_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  %obuild_platform% Windows_NT`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_14
SET obuild_cxx_linker_debug=/DEBUG
:end_if_platform_14
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  %obuild_platform% Windows_NT`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_15
SET obuild_cxx_linker_options=/nologo
:end_if_platform_15
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_app_prog_snovis_sh_16
  SET obuild_cxx_linker_debug_local=%obuild_cxx_linker_debug%
  GOTO end_if_db_build_app_prog_snovis_sh_16
:else_if_db_build_app_prog_snovis_sh_16
  SET obuild_cxx_linker_debug_local=
:end_if_db_build_app_prog_snovis_sh_16

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_app_prog_snovis_sh_17
  SET obuild_cxx_linker_optimize_local=%obuild_cxx_linker_optimize%
  GOTO end_if_opt_build_app_prog_snovis_sh_17
:else_if_opt_build_app_prog_snovis_sh_17
  SET obuild_cxx_linker_optimize_local=
:end_if_opt_build_app_prog_snovis_sh_17

SET obuild_linked_libraries="%obuild_snovis_path%\%obuild_dir_bin%\G4LabUIOnX.lib"
SET obuild_linked_libraries=%obuild_linked_libraries% "%obuild_snovis_path%\%obuild_dir_bin%\G4LabCore.lib"
SET obuild_linked_libraries=%obuild_linked_libraries% "%obuild_snova_path%\%obuild_dir_bin%\snova.lib"
SET obuild_linked_libraries=%obuild_linked_libraries% "%obuild_snova_path%\%obuild_dir_bin%\snvertex.lib"
SET obuild_linked_libraries=%obuild_linked_libraries% "%obuild_snova_path%\%obuild_dir_bin%\sngeom.lib"
SET obuild_linked_libraries=%obuild_linked_libraries% "%obuild_snova_path%\%obuild_dir_bin%\geomutils.lib"
SET obuild_linked_libraries=%obuild_linked_libraries% "%obuild_bhep_path%\%obuild_dir_bin%\bhep.lib"
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  %obuild_platform% Windows_NT`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_25
SET obuild_linked_libraries=%obuild_linked_libraries% glu32.lib opengl32.lib gdi32.lib user32.lib
:end_if_platform_25
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_snovis_0=%%d
cd "%obuild_snovis_path%\%obuild_dir_bin%"
IF EXIST .\app_prog_snovis\tmp_objs DEL .\app_prog_snovis\tmp_objs
FOR %%f IN (.\app_prog_snovis\*.obj) DO ECHO %%f >> .\app_prog_snovis\tmp_objs
REM # Link prog_snovis :
IF EXIST .\prog_snovis.exe DEL .\prog_snovis.exe
@IF %obuild_verbose% == yes @ECHO ON 
%obuild_cxx_linker_command% %obuild_cxx_linker_debug_local% %obuild_cxx_linker_optimize_local% %obuild_cxx_linker_options% /out:.\prog_snovis.exe @.\app_prog_snovis\tmp_objs %obuild_linked_libraries%
@IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 

cd "%obuild_pwd_snovis_0%"
SET obuild_pwd_snovis_0=
REM # Some cleanup :
IF EXIST "%obuild_snovis_path%\%obuild_dir_bin%\app_prog_snovis\tmp_objs" DEL "%obuild_snovis_path%\%obuild_dir_bin%\app_prog_snovis\tmp_objs"
IF EXIST "%obuild_snovis_path%\%obuild_dir_bin%\prog_snovis.ilk" DEL "%obuild_snovis_path%\%obuild_dir_bin%\prog_snovis.ilk"
IF EXIST "%obuild_snovis_path%\%obuild_dir_bin%\prog_snovis.pdb" DEL "%obuild_snovis_path%\%obuild_dir_bin%\prog_snovis.pdb"
IF EXIST "%obuild_snovis_path%\%obuild_dir_bin%\app_prog_snovis\tmp_objs" DEL "%obuild_snovis_path%\%obuild_dir_bin%\app_prog_snovis\tmp_objs"
IF EXIST "%obuild_snovis_path%\%obuild_dir_bin%\prog_snovis.exp" DEL "%obuild_snovis_path%\%obuild_dir_bin%\prog_snovis.exp"

:obuild_return
ENDLOCAL
@ECHO ON
